%define name		tranql
%define version		1.0
%define milestone	M2
%define release		0.%{milestone}.1jpp
%define	section		free


Name:		%{name}
Summary:	TranQL framework for building persistence engines.
Url:		http://tranql.codehaus.org/
Version:	%{version}
Release:	%{release}
Epoch:		0
License:	Apache Software License 2
Group:		Development/Libraries/Java
Vendor:		JPackage Project
Distribution:	JPackage
BuildArch:	noarch
Source0:	tranql-1.0-M2-src.tar.gz
# cvs -d :pserver:anonymous@cvs.tranql.codehaus.org:/home/projects/tranql/scm login  
# cvs -z3 -d :pserver:anonymous@cvs.tranql.codehaus.org:/home/projects/tranql/scm export -r v1_0_M2 tranql
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        tranql-1.0-M2-jpp-depmap.xml


BuildRequires:  jpackage-utils >= 0:1.5
BuildRequires:	ant >= 0:1.6
BuildRequires:	junit
BuildRequires:	maven
BuildRequires:	antlr
BuildRequires:	axion
#
BuildRequires:	jakarta-commons-collections
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-commons-primitives
BuildRequires:	geronimo-specs >= 0:1.0-0.M2
BuildRequires:	regexp
#
Requires:	axion
Requires:	jakarta-commons-collections
Requires:	jakarta-commons-logging
Requires:	jakarta-commons-primitives
Requires:	regexp
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
TranQL is an open source, Apache 2.0 licenced 
framework for building persistence engines.

%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation

%description javadoc
Javadoc for %{name}.

%prep
%setup -q -n %{name}
chmod -R go=u-w *
find . -name "*.jar" -exec rm -f {} \;

export DEPCAT=$(pwd)/tranql-1.0-M2-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > tranql-1.0-M2-depmap.new.xml

#%patch0 -b .sav

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

for p in $(find . -name project.properties); do
    echo >> $p
    echo maven.repo.remote=file:/usr/share/maven-1.0/repository >> $p
    echo maven.home.local=$(pwd)/.maven >> $p
done

mkdir -p .maven/repository/JPP/jars
pushd .maven/repository/JPP/jars
ln -sf $(build-classpath antlr) .
ln -sf $(build-classpath axion) .
ln -sf $(build-classpath commons-collections) .
ln -sf $(build-classpath commons-logging) .
ln -sf $(build-classpath commons-primitives) .
ln -sf $(build-classpath geronimo/spec-j2ee-1.4) geronimo-spec-j2ee-1.4.jar
ln -sf $(build-classpath regexp) .
popd

maven -Dmaven.repo.remote=file:/usr/share/maven-1.0/repository \
	-Dmaven.home.local=$(pwd)/.maven \
	build javadoc:generate

%install
# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{name}-%{version}-%{milestone}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc LICENSE.txt
%{_javadir}/*

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%changelog
* Tue Feb 01 2005 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.M2.1jpp
- Upgrade to M2
- Process project.xml files with saxon
- Don't tamper with $HOME
- Don't use build-jar-repository: [xyz].jar will not work with geronimo deploy

* Mon Oct 04 2004 Ralph Apel <r.apel at r-apel.de> 0:1.0-0.M1.1jpp
- First release

